/* chess-clock.c generated by valac 0.22.0.43-7c3715, the Vala compiler
 * generated from chess-clock.vala, do not modify */

/*
 * Copyright (C) 2010-2013 Robert Ancell
 * Copyright (C) 2013 Michael Catanzaro
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 2 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */

#include <glib.h>
#include <glib-object.h>


#define TYPE_CHESS_CLOCK (chess_clock_get_type ())
#define CHESS_CLOCK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CHESS_CLOCK, ChessClock))
#define CHESS_CLOCK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CHESS_CLOCK, ChessClockClass))
#define IS_CHESS_CLOCK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CHESS_CLOCK))
#define IS_CHESS_CLOCK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CHESS_CLOCK))
#define CHESS_CLOCK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CHESS_CLOCK, ChessClockClass))

typedef struct _ChessClock ChessClock;
typedef struct _ChessClockClass ChessClockClass;
typedef struct _ChessClockPrivate ChessClockPrivate;

#define TYPE_COLOR (color_get_type ())
#define _g_timer_destroy0(var) ((var == NULL) ? NULL : (var = (g_timer_destroy (var), NULL)))

struct _ChessClock {
	GObject parent_instance;
	ChessClockPrivate * priv;
};

struct _ChessClockClass {
	GObjectClass parent_class;
};

typedef enum  {
	COLOR_WHITE,
	COLOR_BLACK
} Color;

struct _ChessClockPrivate {
	gint _white_initial_seconds;
	gint _black_initial_seconds;
	gint _white_seconds_used;
	gint _black_seconds_used;
	Color _active_color;
	GTimer* timer;
	guint expire_timeout_id;
	guint tick_timeout_id;
};


static gpointer chess_clock_parent_class = NULL;

GType chess_clock_get_type (void) G_GNUC_CONST;
GType color_get_type (void) G_GNUC_CONST;
#define CHESS_CLOCK_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_CHESS_CLOCK, ChessClockPrivate))
enum  {
	CHESS_CLOCK_DUMMY_PROPERTY,
	CHESS_CLOCK_WHITE_INITIAL_SECONDS,
	CHESS_CLOCK_BLACK_INITIAL_SECONDS,
	CHESS_CLOCK_WHITE_SECONDS_USED,
	CHESS_CLOCK_BLACK_SECONDS_USED,
	CHESS_CLOCK_ACTIVE_COLOR
};
ChessClock* chess_clock_new (gint white_initial_seconds, gint black_initial_seconds);
ChessClock* chess_clock_construct (GType object_type, gint white_initial_seconds, gint black_initial_seconds);
static void chess_clock_set_white_initial_seconds (ChessClock* self, gint value);
static void chess_clock_set_black_initial_seconds (ChessClock* self, gint value);
void chess_clock_start (ChessClock* self);
static gboolean chess_clock_get_is_active (ChessClock* self);
static void chess_clock_watch_timer (ChessClock* self);
static gboolean chess_clock_timer_expired_cb (ChessClock* self);
void chess_clock_stop (ChessClock* self);
static gboolean chess_clock_tick_cb (ChessClock* self);
Color chess_clock_get_active_color (ChessClock* self);
gint chess_clock_get_white_seconds_used (ChessClock* self);
static void chess_clock_set_white_seconds_used (ChessClock* self, gint value);
gint chess_clock_get_black_seconds_used (ChessClock* self);
static void chess_clock_set_black_seconds_used (ChessClock* self, gint value);
static void chess_clock_stop_watching_timer (ChessClock* self);
void chess_clock_pause (ChessClock* self);
void chess_clock_unpause (ChessClock* self);
gint chess_clock_get_white_initial_seconds (ChessClock* self);
static gboolean _chess_clock_timer_expired_cb_gsource_func (gpointer self);
gint chess_clock_get_black_initial_seconds (ChessClock* self);
static gboolean _chess_clock_tick_cb_gsource_func (gpointer self);
void chess_clock_set_active_color (ChessClock* self, Color value);
static void chess_clock_finalize (GObject* obj);
static void _vala_chess_clock_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_chess_clock_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


ChessClock* chess_clock_construct (GType object_type, gint white_initial_seconds, gint black_initial_seconds) {
	ChessClock * self = NULL;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
#line 44 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	self = (ChessClock*) g_object_new (object_type, NULL);
#line 46 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	_tmp0_ = white_initial_seconds;
#line 46 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	chess_clock_set_white_initial_seconds (self, _tmp0_);
#line 47 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	_tmp1_ = black_initial_seconds;
#line 47 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	chess_clock_set_black_initial_seconds (self, _tmp1_);
#line 44 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	return self;
#line 117 "chess-clock.c"
}


ChessClock* chess_clock_new (gint white_initial_seconds, gint black_initial_seconds) {
#line 44 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	return chess_clock_construct (TYPE_CHESS_CLOCK, white_initial_seconds, black_initial_seconds);
#line 124 "chess-clock.c"
}


void chess_clock_start (ChessClock* self) {
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GTimer* _tmp2_ = NULL;
#line 55 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	g_return_if_fail (self != NULL);
#line 57 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	_tmp0_ = chess_clock_get_is_active (self);
#line 57 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	_tmp1_ = _tmp0_;
#line 57 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	if (_tmp1_) {
#line 58 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
		return;
#line 142 "chess-clock.c"
	}
#line 60 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	_tmp2_ = self->priv->timer;
#line 60 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	if (_tmp2_ == NULL) {
#line 148 "chess-clock.c"
		GTimer* _tmp3_ = NULL;
#line 63 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
		_tmp3_ = g_timer_new ();
#line 63 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
		_g_timer_destroy0 (self->priv->timer);
#line 63 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
		self->priv->timer = _tmp3_;
#line 156 "chess-clock.c"
	} else {
		GTimer* _tmp4_ = NULL;
#line 67 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
		_tmp4_ = self->priv->timer;
#line 67 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
		g_timer_start (_tmp4_);
#line 163 "chess-clock.c"
	}
#line 70 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	chess_clock_watch_timer (self);
#line 167 "chess-clock.c"
}


static gboolean chess_clock_timer_expired_cb (ChessClock* self) {
	gboolean result = FALSE;
#line 73 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 75 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	chess_clock_stop (self);
#line 76 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	g_signal_emit_by_name (self, "expired");
#line 77 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	result = FALSE;
#line 77 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	return result;
#line 183 "chess-clock.c"
}


static gboolean chess_clock_tick_cb (ChessClock* self) {
	gboolean result = FALSE;
	Color _tmp0_ = 0;
	Color _tmp1_ = 0;
#line 80 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 82 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	_tmp0_ = chess_clock_get_active_color (self);
#line 82 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	_tmp1_ = _tmp0_;
#line 82 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	if (_tmp1_ == COLOR_WHITE) {
#line 199 "chess-clock.c"
		gint _tmp2_ = 0;
#line 83 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
		_tmp2_ = self->priv->_white_seconds_used;
#line 83 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
		chess_clock_set_white_seconds_used (self, _tmp2_ + 1);
#line 205 "chess-clock.c"
	} else {
		gint _tmp3_ = 0;
#line 85 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
		_tmp3_ = self->priv->_black_seconds_used;
#line 85 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
		chess_clock_set_black_seconds_used (self, _tmp3_ + 1);
#line 212 "chess-clock.c"
	}
#line 87 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	g_signal_emit_by_name (self, "tick");
#line 89 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	result = TRUE;
#line 89 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	return result;
#line 220 "chess-clock.c"
}


void chess_clock_stop (ChessClock* self) {
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GTimer* _tmp2_ = NULL;
#line 92 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	g_return_if_fail (self != NULL);
#line 94 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	_tmp0_ = chess_clock_get_is_active (self);
#line 94 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	_tmp1_ = _tmp0_;
#line 94 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	if (!_tmp1_) {
#line 95 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
		return;
#line 238 "chess-clock.c"
	}
#line 97 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	_tmp2_ = self->priv->timer;
#line 97 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	g_timer_stop (_tmp2_);
#line 98 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	chess_clock_stop_watching_timer (self);
#line 246 "chess-clock.c"
}


void chess_clock_pause (ChessClock* self) {
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GTimer* _tmp2_ = NULL;
#line 101 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	g_return_if_fail (self != NULL);
#line 103 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	_tmp0_ = chess_clock_get_is_active (self);
#line 103 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	_tmp1_ = _tmp0_;
#line 103 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	if (!_tmp1_) {
#line 104 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
		return;
#line 264 "chess-clock.c"
	}
#line 106 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	_tmp2_ = self->priv->timer;
#line 106 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	g_timer_stop (_tmp2_);
#line 107 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	chess_clock_stop_watching_timer (self);
#line 272 "chess-clock.c"
}


void chess_clock_unpause (ChessClock* self) {
	gboolean _tmp0_ = FALSE;
	GTimer* _tmp1_ = NULL;
	gboolean _tmp4_ = FALSE;
	GTimer* _tmp5_ = NULL;
#line 110 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	g_return_if_fail (self != NULL);
#line 112 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	_tmp1_ = self->priv->timer;
#line 112 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	if (_tmp1_ == NULL) {
#line 112 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
		_tmp0_ = TRUE;
#line 289 "chess-clock.c"
	} else {
		gboolean _tmp2_ = FALSE;
		gboolean _tmp3_ = FALSE;
#line 112 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
		_tmp2_ = chess_clock_get_is_active (self);
#line 112 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
		_tmp3_ = _tmp2_;
#line 112 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
		_tmp0_ = _tmp3_;
#line 299 "chess-clock.c"
	}
#line 112 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	_tmp4_ = _tmp0_;
#line 112 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	if (_tmp4_) {
#line 113 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
		return;
#line 307 "chess-clock.c"
	}
#line 115 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	_tmp5_ = self->priv->timer;
#line 115 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	g_timer_continue (_tmp5_);
#line 116 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	chess_clock_watch_timer (self);
#line 315 "chess-clock.c"
}


static gboolean _chess_clock_timer_expired_cb_gsource_func (gpointer self) {
	gboolean result;
	result = chess_clock_timer_expired_cb (self);
#line 123 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	return result;
#line 324 "chess-clock.c"
}


static gboolean _chess_clock_tick_cb_gsource_func (gpointer self) {
	gboolean result;
	result = chess_clock_tick_cb (self);
#line 130 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	return result;
#line 333 "chess-clock.c"
}


static void chess_clock_watch_timer (ChessClock* self) {
	Color _tmp0_ = 0;
	Color _tmp1_ = 0;
	guint _tmp8_ = 0U;
#line 119 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	g_return_if_fail (self != NULL);
#line 122 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	_tmp0_ = chess_clock_get_active_color (self);
#line 122 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	_tmp1_ = _tmp0_;
#line 122 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	if (_tmp1_ == COLOR_WHITE) {
#line 349 "chess-clock.c"
		gint _tmp2_ = 0;
		gint _tmp3_ = 0;
		guint _tmp4_ = 0U;
#line 123 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
		_tmp2_ = self->priv->_white_initial_seconds;
#line 123 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
		_tmp3_ = self->priv->_white_seconds_used;
#line 123 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
		_tmp4_ = g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) (_tmp2_ - _tmp3_), _chess_clock_timer_expired_cb_gsource_func, g_object_ref (self), g_object_unref);
#line 123 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
		self->priv->expire_timeout_id = _tmp4_;
#line 361 "chess-clock.c"
	} else {
		gint _tmp5_ = 0;
		gint _tmp6_ = 0;
		guint _tmp7_ = 0U;
#line 126 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
		_tmp5_ = self->priv->_black_initial_seconds;
#line 126 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
		_tmp6_ = self->priv->_black_seconds_used;
#line 126 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
		_tmp7_ = g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) (_tmp5_ - _tmp6_), _chess_clock_timer_expired_cb_gsource_func, g_object_ref (self), g_object_unref);
#line 126 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
		self->priv->expire_timeout_id = _tmp7_;
#line 374 "chess-clock.c"
	}
#line 130 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	_tmp8_ = g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) 1, _chess_clock_tick_cb_gsource_func, g_object_ref (self), g_object_unref);
#line 130 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	self->priv->tick_timeout_id = _tmp8_;
#line 380 "chess-clock.c"
}


static void chess_clock_stop_watching_timer (ChessClock* self) {
	guint _tmp0_ = 0U;
	guint _tmp1_ = 0U;
#line 133 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	g_return_if_fail (self != NULL);
#line 135 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	_tmp0_ = self->priv->expire_timeout_id;
#line 135 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	g_source_remove (_tmp0_);
#line 136 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	self->priv->expire_timeout_id = (guint) 0;
#line 137 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	_tmp1_ = self->priv->tick_timeout_id;
#line 137 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	g_source_remove (_tmp1_);
#line 138 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	self->priv->tick_timeout_id = (guint) 0;
#line 401 "chess-clock.c"
}


gint chess_clock_get_white_initial_seconds (ChessClock* self) {
	gint result;
	gint _tmp0_ = 0;
#line 14 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 14 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	_tmp0_ = self->priv->_white_initial_seconds;
#line 14 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	result = _tmp0_;
#line 14 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	return result;
#line 416 "chess-clock.c"
}


static void chess_clock_set_white_initial_seconds (ChessClock* self, gint value) {
	gint _tmp0_ = 0;
#line 14 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	g_return_if_fail (self != NULL);
#line 14 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	_tmp0_ = value;
#line 14 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	self->priv->_white_initial_seconds = _tmp0_;
#line 14 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	g_object_notify ((GObject *) self, "white-initial-seconds");
#line 430 "chess-clock.c"
}


gint chess_clock_get_black_initial_seconds (ChessClock* self) {
	gint result;
	gint _tmp0_ = 0;
#line 16 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 16 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	_tmp0_ = self->priv->_black_initial_seconds;
#line 16 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	result = _tmp0_;
#line 16 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	return result;
#line 445 "chess-clock.c"
}


static void chess_clock_set_black_initial_seconds (ChessClock* self, gint value) {
	gint _tmp0_ = 0;
#line 16 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	g_return_if_fail (self != NULL);
#line 16 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	_tmp0_ = value;
#line 16 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	self->priv->_black_initial_seconds = _tmp0_;
#line 16 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	g_object_notify ((GObject *) self, "black-initial-seconds");
#line 459 "chess-clock.c"
}


gint chess_clock_get_white_seconds_used (ChessClock* self) {
	gint result;
	gint _tmp0_ = 0;
#line 18 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 18 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	_tmp0_ = self->priv->_white_seconds_used;
#line 18 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	result = _tmp0_;
#line 18 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	return result;
#line 474 "chess-clock.c"
}


static void chess_clock_set_white_seconds_used (ChessClock* self, gint value) {
	gint _tmp0_ = 0;
#line 18 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	g_return_if_fail (self != NULL);
#line 18 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	_tmp0_ = value;
#line 18 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	self->priv->_white_seconds_used = _tmp0_;
#line 18 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	g_object_notify ((GObject *) self, "white-seconds-used");
#line 488 "chess-clock.c"
}


gint chess_clock_get_black_seconds_used (ChessClock* self) {
	gint result;
	gint _tmp0_ = 0;
#line 20 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 20 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	_tmp0_ = self->priv->_black_seconds_used;
#line 20 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	result = _tmp0_;
#line 20 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	return result;
#line 503 "chess-clock.c"
}


static void chess_clock_set_black_seconds_used (ChessClock* self, gint value) {
	gint _tmp0_ = 0;
#line 20 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	g_return_if_fail (self != NULL);
#line 20 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	_tmp0_ = value;
#line 20 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	self->priv->_black_seconds_used = _tmp0_;
#line 20 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	g_object_notify ((GObject *) self, "black-seconds-used");
#line 517 "chess-clock.c"
}


Color chess_clock_get_active_color (ChessClock* self) {
	Color result;
	Color _tmp0_ = 0;
#line 25 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 25 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	_tmp0_ = self->priv->_active_color;
#line 25 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	result = _tmp0_;
#line 25 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	return result;
#line 532 "chess-clock.c"
}


void chess_clock_set_active_color (ChessClock* self, Color value) {
	Color _tmp0_ = 0;
	Color _tmp1_ = 0;
	Color _tmp2_ = 0;
	Color _tmp3_ = 0;
#line 26 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	g_return_if_fail (self != NULL);
#line 28 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	_tmp0_ = value;
#line 28 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	_tmp1_ = chess_clock_get_active_color (self);
#line 28 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	_tmp2_ = _tmp1_;
#line 28 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	if (_tmp0_ == _tmp2_) {
#line 29 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
		return;
#line 553 "chess-clock.c"
	}
#line 31 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	chess_clock_stop (self);
#line 32 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	_tmp3_ = value;
#line 32 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	self->priv->_active_color = _tmp3_;
#line 33 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	chess_clock_start (self);
#line 26 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	g_object_notify ((GObject *) self, "active-color");
#line 565 "chess-clock.c"
}


static gboolean chess_clock_get_is_active (ChessClock* self) {
	gboolean result;
	gboolean _tmp0_ = FALSE;
	GTimer* _tmp1_ = NULL;
	gboolean _tmp3_ = FALSE;
#line 52 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 52 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	_tmp1_ = self->priv->timer;
#line 52 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	if (_tmp1_ != NULL) {
#line 580 "chess-clock.c"
		guint _tmp2_ = 0U;
#line 52 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
		_tmp2_ = self->priv->expire_timeout_id;
#line 52 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
		_tmp0_ = _tmp2_ != ((guint) 0);
#line 586 "chess-clock.c"
	} else {
#line 52 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
		_tmp0_ = FALSE;
#line 590 "chess-clock.c"
	}
#line 52 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	_tmp3_ = _tmp0_;
#line 52 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	result = _tmp3_;
#line 52 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	return result;
#line 598 "chess-clock.c"
}


static void chess_clock_class_init (ChessClockClass * klass) {
#line 12 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	chess_clock_parent_class = g_type_class_peek_parent (klass);
#line 12 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	g_type_class_add_private (klass, sizeof (ChessClockPrivate));
#line 12 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_chess_clock_get_property;
#line 12 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_chess_clock_set_property;
#line 12 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	G_OBJECT_CLASS (klass)->finalize = chess_clock_finalize;
#line 12 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CHESS_CLOCK_WHITE_INITIAL_SECONDS, g_param_spec_int ("white-initial-seconds", "white-initial-seconds", "white-initial-seconds", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 12 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CHESS_CLOCK_BLACK_INITIAL_SECONDS, g_param_spec_int ("black-initial-seconds", "black-initial-seconds", "black-initial-seconds", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 12 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CHESS_CLOCK_WHITE_SECONDS_USED, g_param_spec_int ("white-seconds-used", "white-seconds-used", "white-seconds-used", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 12 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CHESS_CLOCK_BLACK_SECONDS_USED, g_param_spec_int ("black-seconds-used", "black-seconds-used", "black-seconds-used", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 12 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CHESS_CLOCK_ACTIVE_COLOR, g_param_spec_enum ("active-color", "active-color", "active-color", TYPE_COLOR, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 12 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	g_signal_new ("tick", TYPE_CHESS_CLOCK, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 12 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	g_signal_new ("expired", TYPE_CHESS_CLOCK, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 627 "chess-clock.c"
}


static void chess_clock_instance_init (ChessClock * self) {
#line 12 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	self->priv = CHESS_CLOCK_GET_PRIVATE (self);
#line 18 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	self->priv->_white_seconds_used = 0;
#line 20 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	self->priv->_black_seconds_used = 0;
#line 22 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	self->priv->_active_color = COLOR_WHITE;
#line 38 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	self->priv->expire_timeout_id = (guint) 0;
#line 39 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	self->priv->tick_timeout_id = (guint) 0;
#line 644 "chess-clock.c"
}


static void chess_clock_finalize (GObject* obj) {
	ChessClock * self;
#line 12 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CHESS_CLOCK, ChessClock);
#line 37 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	_g_timer_destroy0 (self->priv->timer);
#line 12 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	G_OBJECT_CLASS (chess_clock_parent_class)->finalize (obj);
#line 656 "chess-clock.c"
}


GType chess_clock_get_type (void) {
	static volatile gsize chess_clock_type_id__volatile = 0;
	if (g_once_init_enter (&chess_clock_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ChessClockClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) chess_clock_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ChessClock), 0, (GInstanceInitFunc) chess_clock_instance_init, NULL };
		GType chess_clock_type_id;
		chess_clock_type_id = g_type_register_static (G_TYPE_OBJECT, "ChessClock", &g_define_type_info, 0);
		g_once_init_leave (&chess_clock_type_id__volatile, chess_clock_type_id);
	}
	return chess_clock_type_id__volatile;
}


static void _vala_chess_clock_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	ChessClock * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CHESS_CLOCK, ChessClock);
#line 12 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	switch (property_id) {
#line 12 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
		case CHESS_CLOCK_WHITE_INITIAL_SECONDS:
#line 12 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
		g_value_set_int (value, chess_clock_get_white_initial_seconds (self));
#line 12 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
		break;
#line 12 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
		case CHESS_CLOCK_BLACK_INITIAL_SECONDS:
#line 12 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
		g_value_set_int (value, chess_clock_get_black_initial_seconds (self));
#line 12 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
		break;
#line 12 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
		case CHESS_CLOCK_WHITE_SECONDS_USED:
#line 12 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
		g_value_set_int (value, chess_clock_get_white_seconds_used (self));
#line 12 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
		break;
#line 12 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
		case CHESS_CLOCK_BLACK_SECONDS_USED:
#line 12 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
		g_value_set_int (value, chess_clock_get_black_seconds_used (self));
#line 12 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
		break;
#line 12 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
		case CHESS_CLOCK_ACTIVE_COLOR:
#line 12 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
		g_value_set_enum (value, chess_clock_get_active_color (self));
#line 12 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
		break;
#line 707 "chess-clock.c"
		default:
#line 12 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 12 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
		break;
#line 713 "chess-clock.c"
	}
}


static void _vala_chess_clock_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	ChessClock * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CHESS_CLOCK, ChessClock);
#line 12 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
	switch (property_id) {
#line 12 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
		case CHESS_CLOCK_WHITE_INITIAL_SECONDS:
#line 12 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
		chess_clock_set_white_initial_seconds (self, g_value_get_int (value));
#line 12 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
		break;
#line 12 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
		case CHESS_CLOCK_BLACK_INITIAL_SECONDS:
#line 12 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
		chess_clock_set_black_initial_seconds (self, g_value_get_int (value));
#line 12 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
		break;
#line 12 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
		case CHESS_CLOCK_WHITE_SECONDS_USED:
#line 12 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
		chess_clock_set_white_seconds_used (self, g_value_get_int (value));
#line 12 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
		break;
#line 12 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
		case CHESS_CLOCK_BLACK_SECONDS_USED:
#line 12 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
		chess_clock_set_black_seconds_used (self, g_value_get_int (value));
#line 12 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
		break;
#line 12 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
		case CHESS_CLOCK_ACTIVE_COLOR:
#line 12 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
		chess_clock_set_active_color (self, g_value_get_enum (value));
#line 12 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
		break;
#line 753 "chess-clock.c"
		default:
#line 12 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 12 "/home/mcatanzaro/jhbuild/src/gnome-chess/src/chess-clock.vala"
		break;
#line 759 "chess-clock.c"
	}
}



